// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2008, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.
package com.ibm.websphere.batch.samples.tests.bds;

import java.util.HashMap;

public class EchoDataHolder {

	public HashMap dbData = null;
	public String stringData = null;
	public byte[] byteData = null;
	public int nread = -1;
	
	protected boolean isByte = false;
	protected boolean isString = false;
	protected boolean isMap = false;
	
	public static String EchoDataHolderKey = "EchoDataHolder";
	
	public String toString()
	{
		return getStringData();
	}
	
	public EchoDataHolder(byte[] byteData, int nread)
	{
		this.byteData = byteData;
		this.nread = nread;
		isByte = true;
	}
	
	public EchoDataHolder(String stringData)
	{
		this.stringData = stringData;
		nread = stringData.length();
		isString = true;
	}
	
	public EchoDataHolder(HashMap map)
	{
		this.dbData = map;	
		this.stringData = (String)map.get("RECORD");//toString();
		this.nread = stringData.length();
		isMap = true;
	}
	
	public HashMap getMapData()
	{
		if (isMap)
			return dbData;
		else
		{
			HashMap retval = new HashMap();
			String val = getStringData();
			retval.put(EchoDataHolder.EchoDataHolderKey, val);
			return retval;
		}
	}
	public String getStringData()
	{
		if (isByte)
			return new String(byteData);
		
		else if (isString)
			return stringData;
		
		else if (isMap)
			return stringData;
				
		else throw new RuntimeException("EchoDataHolder.getStringData()- no data defined");
	}
	
	public byte[] getByteData()
	{
		if (isByte)
		{
			if (nread > 0)
				return byteData;
			else throw new RuntimeException("EchoDataHolder.getByteData() - no data in buffer!");
		}
		else if (isString)
			return stringData.getBytes();
		else if (isMap)
			return stringData.getBytes();		
		else throw new RuntimeException("EchoDataHolder.getByteData() - no data defined");
	}
}
