// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2008, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.
package com.ibm.websphere.batch.samples.tests.steps;

import java.util.Properties;

import com.ibm.websphere.batch.BatchConstants;
import com.ibm.websphere.batch.BatchJobStepInterface;

public class PingStep implements BatchJobStepInterface {

	public String iterationsKey = "iterations";
	protected int max_iterations = 50000;
	protected int iterations = 0;
	protected Properties props;
	
	public void createJobStep() {
		
		String prop = props.getProperty(iterationsKey);
		if (prop != null)
		{
			try
			{
				max_iterations = Integer.valueOf(prop).intValue();				
			}
			catch (Exception e)
			{
				System.out.println("Error parsing iterations value for PingStep. Defaulting to: " + max_iterations);
			}
		}
	}

	public int destroyJobStep() {		
		return 0;
	}

	public Properties getProperties() {
		return this.props;
	}

	public int processJobStep() {
		
		if (iterations >= max_iterations)
			return BatchConstants.STEP_COMPLETE;
		else
		{
			iterations++;
			return BatchConstants.STEP_CONTINUE;
		}
	}

	public void setProperties(Properties props) {
		this.props = props;
	}

}
