// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2008, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.
/*
 * Created on May 24, 2007
 */
package com.ibm.websphere.batch.samples.tests.steps;

import java.util.Iterator;
import java.util.Properties;
import java.util.Set;

import com.ibm.websphere.batch.BatchConstants;
import com.ibm.websphere.batch.context.JobStepContext;
import com.ibm.websphere.batch.context.JobStepContextMgr;
import com.ibm.websphere.batch.listener.JobListener;

/**
 *  Sample implementation of JobListener
 */


public class TestJobListener implements JobListener {

    private Properties props;

	/* (non-Javadoc)
	 * @see com.ibm.websphere.batch.listener.JobListener#afterJob()
	 */
	public void afterJob() {
		System.out.println("TestJobListener.afterJob()");
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.batch.listener.JobListener#afterStep()
	 */
	public void afterStep() {
		System.out.println("TestJobListener.afterStep()");

	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.batch.listener.JobListener#beforeJob()
	 */
	public void beforeJob() {
		System.out.println("TestJobListener.beforeJob()");
		//get properties and print
		Set propNames = props.keySet();
		Iterator<String> itr = propNames.iterator();
		while  (itr.hasNext()){
			String name = (String)itr.next();
			System.out.println("JobListener  prop name=" + name + ", value=" + props.getProperty(name));
		}
		
		//get submitter id
		JobStepContext context = JobStepContextMgr.getContext();
		System.out.println("Job Id = " + context.getJobID());
		System.out.println("Submitter Id = " + context.getSubmitterID());
		//get JobListener prop from context
		System.out.println("JobListener prop from context = " + context.getJobListenerProperties().toString());
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.batch.listener.JobListener#beforeStep()
	 */
	public void beforeStep() {
		System.out.println("TestJobListener.beforeStep()");
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.batch.listener.JobListener#getProperties()
	 */
	public Properties getProperties() {
		return props;
	}

	public void setProperties(Properties properties) {
        this.props = properties;
        	
	}

}
